#include "StdAfx.h"
#include "resource.h"
#include "MainWnd.h"
 
 
#include "cpss_dialog.h"
 extern HANDLE ghEventExit;
 HFONT m_hBigFont=NULL,m_hSmallFont=NULL;
extern BOOL g_bReifenAlert;
#define m_btncancel m_Btns[0]
#define m_btnShowlist  m_Btns[1]
#define m_btnlist  (&m_Btns[2])
CPoint pt(5,5);
 
#define __MIN(x,y) (x>y)?y:x
  
static const struct BTN_CFG{
	int idImage;
	//int idImageDis;
	int idTitle;
} gBtnCfg[]={ {IDBI_BORD_0, IDS_BORD_MENU0},{IDBI_BORD_1, IDS_BORD_MENU1},{IDBI_BORD_2, IDS_BORD_MENU2},
	{IDBI_BORD_3, IDS_BORD_MENU3},{IDBI_BORD_4, IDS_BORD_MENU4}

};

#define _Y 16
//static BUTTON_ITEMEX Button_Info = 	 
//	{ 110, 30,331,72,0,	IDB_BTN_551x97,IDB_BTN_551x97_DN, 0, 0, 0,0,TitleFontWide,TitleFontHeight,FW_NORMAL/*,FALSE*/};
 
static const BUTTON_ITEMEX Button_Info[] =  {	 
	{ 110, 30+_Y,331,72,IDS_BORD_MENU0,	IDB_MENU_ZEITEN,IDB_MENU_ZEITEN_DN, 0, 0, 0,0,TitleFontWide,TitleFontHeight,FW_NORMAL/*,FALSE*/},
	{ 110, 130+_Y,331,72,IDS_BORD_MENU1,	IDB_MENU_CAN,IDB_MENU_CAN_DN, 0, 0, 0,0,TitleFontWide,TitleFontHeight,FW_NORMAL/*,FALSE*/},
	{ 110, 230+_Y,331,72,IDS_BORD_MENU2,	IDB_MENU_REIFEN,IDB_MENU_REIFEN_DN, 0, 0, 0,0,TitleFontWide,TitleFontHeight,FW_NORMAL/*,FALSE*/},
	{ 110, 330+_Y,331,72,IDS_BORD_MENU3,	IDB_MENU_TANK,IDB_MENU_TANK_DN, 0, 0, 0,0,TitleFontWide,TitleFontHeight,FW_NORMAL/*,FALSE*/},
	{ 110, 30+_Y,331,72,IDS_BORD_MENU4,	IDB_MENU_WIRT,IDB_MENU_WIRT_DN, 0, 0, 0,0,TitleFontWide,TitleFontHeight,FW_NORMAL/*,FALSE*/}
};
BUTTON_ITEM const Button_Cancel[2] ={ { Btn_CancelX, Btn_CancelY , Btn_CancelWidth,Btn_CancelHeight,ID_CANCEL,	IDBI_CANCEL,IDBI_CANCEL_DN},
{0,0,0,0,0,0,0}};


static const SCROLL_ITEM mScreelInfoMsgView={DEF_SCROLL_RECT,NULL,0,0,73,44,
                          IDB_ADDRSCOLL_BT_UP,IDB_ADDRSCOLL_BT_UP_DN,IDB_ADDRSCOLL_BT_DW,IDB_ADDRSCOLL_BT_DW_DN};

LRESULT CMainWnd::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CString str;
	VButtonWnd::OnInitDialog( uMsg,  wParam,  lParam,  bHandled);
 
	//str.LoadString(Button_Info[count].uId);
	//CREATE_BTN_TRANS(m_btnlist[count], m_nIDBACK,str,Button_Info[count]);
 
	m_count = 5; 

	CREATE_BTN_TRANS2(m_btncancel, m_nIDBACK,Button_Cancel[0]);

	int count = __MIN(m_count,4);
 
	int i;
 /*
	for(i=0 ; i<count ; i++)
	{
		str.LoadString(gBtnCfg[i].idTitle);
		Button_Info.uId = gBtnCfg[i].idTitle;
		CREATE_BTN_TRANS(m_btnlist[i], m_nIDBACK,str,Button_Info);
		Button_Info.rt.top+= 96;Button_Info.rt.bottom+= 96;
		//m_btnlist[i].set_check_image(gBtnCfg[i].idImage, pt);
		//m_btnlist[i].setTag(gBtnCfg[i].idImage, pt);
	}
 */
	for(i=0;i<count;i++){
		str.LoadString(Button_Info[i].uId);
		CREATE_BTN_TRANS(m_btnlist[i], m_nIDBACK,str,Button_Info[i]);
	}

	cScrollBar.CreateWnd(m_hWnd,IDB_LISTSCOLL_BK,m_nIDBACK,&mScreelInfoMsgView,0);
	m_pScrollbar=&cScrollBar;
    cScrollBar.DownEnable(m_count>4);
	cScrollBar.UpEnable(0);


	m_hBigFont = create_main_font_41(26);//(38);
	m_hSmallFont = create_main_font_41(22);//(30);

	if(g_bReifenAlert) 
		PostMessage(WM_COMMAND, IDS_BORD_MENU2,0);
	g_bReifenAlert = FALSE;
return 0;
}


void CMainWnd::UpdateUI()
{
	//if(!has_marker())  m_btnShowlist.ChangeBtnAppear(m_nIDBACK, Button_Empty[0].bmpId,Button_Empty[0].bmpId_dn) ;
	//else m_btnShowlist.ChangeBtnAppear(m_nIDBACK, Button_Info[1].bmpId,Button_Info[1].bmpId_dn) ;
}


LRESULT CMainWnd::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	//PostQuitMessage(0);
	if(m_hBigFont) DeleteObject(m_hBigFont);
 
	if(m_hSmallFont) DeleteObject(m_hSmallFont);
	 m_hBigFont=NULL,m_hSmallFont=NULL;


//	if( ghEventExit) SetEvent(ghEventExit);  // do not close app if is service.
return 0;
}

void SelStatusWndMessage(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);

	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(0,0,0));
	//Draw.SetDrawFontSize( LongTitleFontHeight+4, LongTitleFontWide+2,FW_BOLD,__FONT_NORMAL__);
	Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
	Draw.DrawGPSOverIPStringRect(msg,CRect(30,150,766,320),DT_CENTER/*|DT_VCENTER*/|DT_EXPANDTABS );
}
void AlertBox(CString strTitle,int logo=0)
{
		int bkId = IDB_BK;
		if(logo==0) bkId =IDB_BK_POP_DETAIL;
		CpssMsgDlg dlg1(bkId,strTitle,logo);	
		dlg1.m_BmpButtonTmpl = Button_Cancel;
		dlg1.m_TxtButtonTmpl = 0;
		dlg1.fnDrawMessage = SelStatusWndMessage;
		dlg1.m_bSound=1;
		dlg1.DoModal();
}
 
static void MyMessageGeo(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);

	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(0,0,0));
	Draw.SetDrawFontSize(TitleFontHeight,TitleFontWide,FW_NORMAL,__FONT_NORMAL__);
	Draw.DrawGPSOverIPStringRect(msg,CRect(30,100,746,140),DT_CENTER/*|DT_VCENTER*/|DT_EXPANDTABS );
	Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
	if(pExtra) Draw.DrawGPSOverIPStringRect(pExtra,CRect(60,150,740,300),DT_CENTER/*|DT_VCENTER*/|DT_EXPANDTABS );
}
 
 
#include "CN828_Board.h"
#include "FMSCANDlg.h"
#include "WirtschaDlg.h"
#include "Tanks.h"
#include "ReifenDlg.h"
static int ReifenStatus = -1;
LRESULT CMainWnd::OnBordMenu(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	wID -= IDS_BORD_MENU0;
	switch(wID)
	{
	case 0:
		{
			CN828VUBoard brd;
		 
			brd.DoModal();
		}
		break;
	case 1:
		{
			FMSCANDlg dlg;
		 
			dlg.DoModal();
		}
		break;
	case 2:
		{
			if(ReifenStatus==-1){
				ReifenDlg dlg;
				ReifenStatus = wID;
				dlg.DoModal();
				ReifenStatus = -1;
			}
		}
		break;
	case 3:
		{
			TankStatic dlg;
			 
			dlg.DoModal();
		}
		break;
	case 4:
		{
			WirtschaDlg dlg;
			 
			dlg.DoModal();
		}
		break;
	}

	
return 0;
}

 

LRESULT CMainWnd::OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	//PostMessage(WM_CLOSE);
	//EndDialog(0);
	DestroyWindow();
return 0;
}


LRESULT CMainWnd::OnScroll(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	if (wParam == 0)
	{
		if(m_off>0) 
		{
			m_off--;
			cScrollBar.UpEnable(m_off>0);
			cScrollBar.DownEnable( m_count-m_off>4);
			CString str;
			int count = __MIN(m_count,4);
			for(DWORD i=m_off ; i<count+m_off ; i++)
			{
				str.LoadString(gBtnCfg[i].idTitle);					 
		
				m_btnlist[i-m_off].m_nCmdID=(gBtnCfg[i].idTitle);
				m_btnlist[i-m_off].ChangeBtnCaption(str);
				//m_btnlist[i-m_off].set_check_image(gBtnCfg[i].idImage, pt);	
				m_btnlist[i-m_off].ChangeBtnAppear(m_nIDBACK,Button_Info[i].bmpId,Button_Info[i].bmpId_dn);
				 
			}
		}
	}else
	{
		if(m_off<m_count-4){
			m_off++;
			cScrollBar.DownEnable(m_count-m_off>4);
			cScrollBar.UpEnable(m_off>0);
			CString str ;
			int count = __MIN(m_count,4);
			for(DWORD i=m_off ; i<count+m_off ; i++)
			{
				str.LoadString(gBtnCfg[i].idTitle);					 
		
				m_btnlist[i-m_off].m_nCmdID=(gBtnCfg[i].idTitle);
				m_btnlist[i-m_off].ChangeBtnCaption(str);
				//m_btnlist[i-m_off].set_check_image(gBtnCfg[i].idImage, pt);	
				m_btnlist[i-m_off].ChangeBtnAppear(m_nIDBACK,Button_Info[i].bmpId,Button_Info[i].bmpId_dn);
			}
		}
	}

	return 0;
}