#include "stdafx.h"
#include  "t51handle.h"
#include <list>


CSimpleMap<int ,UI_CALLBACK_FUNC> g_mapCallback;

void register_ui_callback(int id,UI_CALLBACK_FUNC func)
{
	g_mapCallback.Add(id, func);
}
int write_gateway_file_t52(BYTE* msg ,int msglen)
{
	static DWORD filenum = 0;
	FILE *f;
	char szName[128];
	BOOL bOK = FALSE;
	WIN32_FIND_DATA fndData;
	HANDLE hFind;

	hFind = FindFirstFile(L"\\DataOverIP\\OUT\\*.T55", &fndData);	
	if(hFind==INVALID_HANDLE_VALUE) filenum=0;
	else FindClose(hFind);
	do{
		sprintf(szName,"\\DataOverIP\\OUT\\%05x.T55" , filenum++);
		f = fopen(szName, "rb");
		if(f)
		{
			fclose(f);
		}else{
			bOK = TRUE; break;
		}
	}while(1);
	f = fopen(szName,"wb");
	if(f)
	{
		fwrite(msg, 1, msglen,f);
		fclose(f);
		return 0;
	}else return -1;
}
 
void CleanupInit()
{
	CreateDirectory(L"\\bordlog",NULL);
	WIN32_FIND_DATA fndData;
	HANDLE hFind;
	hFind = FindFirstFile(L"\\bordlog\\*.F55", &fndData);	
	if (INVALID_HANDLE_VALUE != hFind) 	
	{
		do{
			DeleteFile(fndData.cFileName);
		}while(FindNextFile(hFind, &fndData));
		CloseHandle(hFind);
	}
	load_tire_cfg();
}
BOOL CleanupFile(TCHAR* wcs)
{
#ifdef __REL__
	BOOL b = DeleteFile(wcs );
#else
	static int loo = 0;
	TCHAR dest[128];
	//CreateDirectory(L"\\bordlog",NULL);
	TCHAR*p = wcsrchr(wcs,'\\');
	if(p) p++;else p = wcs;
	wsprintf(dest,L"\\bordlog\\%03d_%s",loo++,p);
	DeleteFile(dest);
	BOOL b = MoveFile(wcs,dest);
#endif
	return b;
}



 

#define UPDATE_LE_LIST(hWnd,msg, wParam, lParam) \
	if(hWnd) SendMessage(hWnd,msg, wParam, lParam)

void put_time_stamp(SYSTEMTIME *pTM)
{
	GetSystemTime(pTM);
	SystemTimeToTzSpecificLocalTime(NULL,pTM,pTM) ;

}
void clear_time_stamp(SYSTEMTIME *pTM)
{
	memset(pTM,0, sizeof(SYSTEMTIME));
}

static TCHAR wcs_val[64];
TCHAR * convert_val(char*ptr,TCHAR* unit)
{
	if(strlen(ptr)==0) wcscpy(wcs_val,L"---");
	else{
		mbstowcs( wcs_val,ptr,strlen(ptr)+1);
		if(unit)
		{
			/*if(wcscmp(unit, TEMP_UNIT)==0){
				CString str;
				str.LoadString(IDS_TEMP_UNIT);
				wcscat(wcs_val, (LPTSTR)(LPCTSTR)str);
			}else*/
			{
				wcscat(wcs_val, unit);
			}
		}
	}
	return wcs_val;
}
void convert_pos( BYTE* pLon, BYTE* pLat, float* fLon,float* fLat)
{
	DWORD dwLon=0,dwLat=0;
	BY2DW(dwLon,pLon);
	BY2DW(dwLat,pLat);
	*fLon = dwLon/600000.;
	*fLat = dwLat/600000.;
}
void convert_pos2( float fLon,float fLat ,BYTE* pLon, BYTE* pLat)
{
	DWORD dwLon,dwLat;
	dwLon = (DWORD) fLon*600000;
	dwLat = (DWORD) fLat*600000;
	//memcpy(pLon ,&dwLon,4);memcpy(pLat,&dwLat, 4);
	DW2BY(dwLon,pLon);
	DW2BY(dwLat,pLat);
}
DWORD diff_time(SYSTEMTIME* tm1, SYSTEMTIME *tm2)
{
	FILETIME ftm1,ftm2;
	SystemTimeToFileTime(tm1,&ftm1);
	SystemTimeToFileTime(tm2,&ftm2);

	DWORD64 sys = ftm1.dwHighDateTime;  
	 sys = sys << 32;  
	 sys += ftm1.dwLowDateTime;  

	 DWORD64 sys0 = ftm2.dwHighDateTime;  
	 sys0 = sys0 << 32;  
	 sys0 += ftm2.dwLowDateTime;  
	
			
	DWORD left = (sys>sys0)? ( (sys-sys0)/600000000 ):0;
	return left ;
}
 

 
int  handle_t51_msg(HWND hWnd)
{
	int err = 0;
	int bHandled = FALSE; 
	
	std::list<std::string> filelist;
	char mbs[128] ;
	WIN32_FIND_DATA fndData;
	HANDLE hFind;
	hFind = FindFirstFile(L"\\DataOverIP\\IN\\*.F55", &fndData);	
	if (INVALID_HANDLE_VALUE != hFind) 	
	{
		do{
			wcstombs(mbs,fndData.cFileName,wcslen(fndData.cFileName)+1);
			filelist.push_back(mbs);
		}while(FindNextFile(hFind, &fndData));
		CloseHandle(hFind);
	}else
	{
		void update_cfg();
		update_cfg();
		
		return 0 ;
	}
	//filelist.sort();
	std::list<std::string>::iterator it = filelist.begin();
	int count = filelist.size();
	__alarmLog("handle_t56_msg, found %d files\n",filelist.size() ) ;
	UI_CALLBACK_FUNC lastfunc = NULL ;
	while(it!=filelist.end())
	{
		std::string filepath = *it;
		char szPath[128];
		sprintf(szPath,"\\DataOverIP\\IN\\%s", it->c_str() );
		FILE* f = fopen( szPath,"rb");
		BYTE  buf[64];
		 
		if(f)
		{
			memset(buf,0xff,sizeof(buf));
			int n = fread(buf, 1, 63, f);
			int len = buf[0];					
			int tmp = 0;
			UI_CALLBACK_FUNC func = g_mapCallback.Lookup( buf[1]);
			if(func!=NULL)
			{
				func( &buf[1],hWnd);
				if(lastfunc!=func)
				{
					if(lastfunc!=NULL)
					{
						lastfunc(NULL,hWnd);
						lastfunc = NULL;
					}else lastfunc = func;
				}
			}

			 
			fclose(f);
			TCHAR wcs[128];
			mbstowcs(wcs,szPath, strlen(szPath)+1);
			BOOL b = CleanupFile(wcs );
			SYSTEMTIME st;
			GetLocalTime(&st);
			 
		}
		it++;
	}
	if(lastfunc!=NULL)
		lastfunc(NULL,hWnd);

#ifndef __REL__
	if(err==1) MessageBox(NULL,L"Error chip index is too larger",L"T52",MB_OK);
	if(err==2) MessageBox(NULL,L"Can not find mac",L"T52",MB_OK);
	if(err==3) MessageBox(NULL,L"Memory almost full",L"T52",MB_OK);
#endif
	if(bHandled )
	{
		UPDATE_LE_LIST(hWnd,WM_USER_LECHIP, LE_UPDATE, 0);
	}
	return bHandled ;
}

void t55_get_fms()
{
	BYTE msg[21] ;
	int msglen = 2;
	msg[0]=msglen-1,msg[1]=2;
	write_gateway_file_t52(msg ,msglen);
}
void t55_reset_fms()
{
	BYTE msg[21] ;
	int msglen = 2;
	msg[0]=msglen-1,msg[1]=0x82;
	write_gateway_file_t52(msg ,msglen);
}
 
void t55_get_wirt()
{
	BYTE msg[21] ;
	int msglen = 2;
	msg[0]=msglen-1,msg[1]=5;
	write_gateway_file_t52(msg ,msglen);
}
void t55_reset_wirt()
{
	BYTE msg[21] ;
	int msglen = 2;
	msg[0]=msglen-1,msg[1]=0x85;
	write_gateway_file_t52(msg ,msglen);
}
void t55_get_zeit()
{
	BYTE msg[21] ;
	int msglen = 2;
	msg[0]=msglen-1,msg[1]=6;
	write_gateway_file_t52(msg ,msglen);
}
void t55_reset_zeit()
{
	BYTE msg[21] ;
	int msglen =2;
	msg[0]=msglen-1,msg[1]=0x86;
	write_gateway_file_t52(msg ,msglen);
}
 
void t55_get_reifen()
{
	BYTE msg[21] ;
	int msglen = 2;
	msg[0]=msglen-1,msg[1]=1;
	write_gateway_file_t52(msg ,msglen);
}
void t55_reset_reifen()
{
	BYTE msg[21] ;
	int msglen = 2;
	msg[0]=msglen-1,msg[1]=0x81;
	write_gateway_file_t52(msg ,msglen);
}

void t55_send_alarm(BYTE*data)
{
		BYTE msg[21] ;
	int msglen = 14;
	msg[0]=msglen-1,msg[1]=0x1;msg[2]=0x4;
	memcpy( &msg[3], data,11);
	write_gateway_file_t52(msg ,msglen);
}

static  void MyMessage(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);
	CRect rc(120,220,680,300);
	
	if(msg)
	{
		int n = wcslen(msg);
		int style=0;
		if(n>400) style = DT_LEFT|DT_TOP|DT_EXPANDTABS;
		else style = DT_CENTER|DT_EXPANDTABS;
		Draw.SetMsgBoxFont();
		if(!pExtra) rc.top-=40;
		Draw.DrawGPSOverIPStringRect(msg, rc,style );
	}
	if(pExtra)
	{
		Draw.SetDrawFontSize(TitleFontHeight,TitleFontWide,FW_NORMAL,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(pExtra, CRect(120,160,680,400),DT_CENTER );
	}
} 
void upper(char *str1)
{
    while(*str1!='\0')
    {
        if(*str1>96&&*str1<123)
            *str1=*str1-32;
        str1++;
    }
}

int hex_to_val( char ch)
{
    if (ch >= '0' && ch <= '9')
        return ch - '0';  /* Simple ASCII arithmetic */
    else if (ch >= 'a' && ch <= 'f')
        return 10 + ch - 'a';  /* Because hex-digit a is ten */
    else if (ch >= 'A' && ch <= 'F')
        return 10 + ch - 'A';  /* Because hex-digit A is ten */
    else
        return -1;  /* Not a valid hexadecimal digit */
}
static TCHAR* g_wcsMonth[] = {L"Jan",L"Feb",L"Mar",L"April",L"May",L"June",L"July",
L"Aug" , L"Sept",L"Oct", L"Nov", L"Dec" }; 
TCHAR * get_month( int month)
{
	if(month<0 && month>=12) month = 0;
	return g_wcsMonth[month];
	 
}